'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.FieldArrayEntry = exports.FieldArray = undefined;

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _provider = require('../provider/provider');

var _provider2 = require('../provider/provider.actions');

var _baseField = require('./base-field');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FieldArray = exports.FieldArray = function (_React$Component) {
    _inherits(FieldArray, _React$Component);

    function FieldArray(props) {
        _classCallCheck(this, FieldArray);

        var _this = _possibleConstructorReturn(this, (FieldArray.__proto__ || Object.getPrototypeOf(FieldArray)).call(this, props));

        _this.state = {
            entries: []
        };

        _this.handleFieldArrayChangeForward = _this.handleFieldArrayChangeForward.bind(_this);
        _this.bindDispatchFieldArrayEntryPush = _this.bindDispatchFieldArrayEntryPush.bind(_this);
        _this.bindDispatchFieldArrayEntryRemove = _this.bindDispatchFieldArrayEntryRemove.bind(_this);
        return _this;
    }

    _createClass(FieldArray, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            document.addEventListener(_provider2.REACT_FORMCTRL.EVENTS.FIELD_ARRAY_CHANGED + '#' + form + '#' + group, this.handleFieldArrayChangeForward);
        }
    }, {
        key: 'handleFieldArrayChangeForward',
        value: function handleFieldArrayChangeForward(event) {
            var _this2 = this;

            this.setState(function (state) {
                entries: event.detail.entries.map(function (entry) {
                    return _extends({}, entry, {
                        removeEntry: _this2.bindDispatchFieldArrayEntryRemove(entry.index)
                    });
                });
            });
        }
    }, {
        key: 'bindDispatchFieldArrayEntryRemove',
        value: function bindDispatchFieldArrayEntryRemove(index) {
            var _props = this.props,
                form = _props.form,
                name = _props.name;

            return function () {
                return _provider.FormEventDispatcher.dispatchFieldArrayEntryRemove(form, name, index);
            };
        }
    }, {
        key: 'bindDispatchFieldArrayEntryPush',
        value: function bindDispatchFieldArrayEntryPush() {
            var _props2 = this.props,
                form = _props2.form,
                name = _props2.name;

            return function (initialValues) {
                return _provider.FormEventDispatcher.dispatchFieldArrayEntryPush(form, name, initialValues);
            };
        }
    }, {
        key: 'render',
        value: function render() {
            return this.props.render(this.state.entries, this.bindDispatchFieldArrayEntryPush());
        }
    }]);

    return FieldArray;
}(_react2.default.Component);

FieldArray.propTypes = {
    form: _propTypes2.default.string.isRequired,
    name: _propTypes2.default.string.isRequired,
    render: _propTypes2.default.func.isRequired,
    withEmptyEntry: _propTypes2.default.bool,
    initialValues: _propTypes2.default.arrayOf(_propTypes2.default.any)
};

var FieldArrayEntry = exports.FieldArrayEntry = function (_BaseField) {
    _inherits(FieldArrayEntry, _BaseField);

    function FieldArrayEntry() {
        _classCallCheck(this, FieldArrayEntry);

        return _possibleConstructorReturn(this, (FieldArrayEntry.__proto__ || Object.getPrototypeOf(FieldArrayEntry)).apply(this, arguments));
    }

    _createClass(FieldArrayEntry, [{
        key: 'getFieldId',
        value: function getFieldId() {
            var _props3 = this.props,
                _props3$entry = _props3.entry,
                form = _props3$entry.form,
                group = _props3$entry.group,
                index = _props3$entry.index,
                name = _props3.name;

            return form + '#' + group + '#' + index + '#' + name;
        }
    }, {
        key: 'dispatchRegisterField',
        value: function dispatchRegisterField() {
            var _props4 = this.props,
                _props4$entry = _props4.entry,
                form = _props4$entry.form,
                group = _props4$entry.group,
                index = _props4$entry.index,
                name = _props4.name;

            _provider.FormEventDispatcher.dispatchRegisterField(form, name, this.state, group, index);
        }
    }, {
        key: 'dispatchFieldPropsChanged',
        value: function dispatchFieldPropsChanged(nextFieldProps) {
            var _props5 = this.props,
                _props5$entry = _props5.entry,
                form = _props5$entry.form,
                group = _props5$entry.group,
                index = _props5$entry.index,
                name = _props5.name;

            _provider.FormEventDispatcher.dispatchFieldPropsChanged(form, name, nextFieldProps, group, index);
        }
    }, {
        key: 'dispatchUnregisterField',
        value: function dispatchUnregisterField() {
            var _props6 = this.props,
                _props6$entry = _props6.entry,
                form = _props6$entry.form,
                group = _props6$entry.group,
                index = _props6$entry.index,
                name = _props6.name;

            _provider.FormEventDispatcher.dispatchUnregisterField(form, name, group, index);
        }
    }, {
        key: 'dispatchFieldChanged',
        value: function dispatchFieldChanged(value, files) {
            var _props7 = this.props,
                _props7$entry = _props7.entry,
                form = _props7$entry.form,
                group = _props7$entry.group,
                index = _props7$entry.index,
                name = _props7.name;

            _provider.FormEventDispatcher.dispatchFieldChanged(form, name, value, files, group, index);
        }
    }, {
        key: 'dispatchFieldBlur',
        value: function dispatchFieldBlur(nextState) {
            var _props8 = this.props,
                _props8$entry = _props8.entry,
                form = _props8$entry.form,
                group = _props8$entry.group,
                index = _props8$entry.index,
                name = _props8.name;

            _provider.FormEventDispatcher.dispatchFieldBlur(form, name, nextState, group, index);
        }
    }, {
        key: 'getChildProps',
        value: function getChildProps() {
            var _props$entry = this.props.entry,
                form = _props$entry.form,
                group = _props$entry.group,
                index = _props$entry.index;

            return _extends({}, _get(FieldArrayEntry.prototype.__proto__ || Object.getPrototypeOf(FieldArrayEntry.prototype), 'getChildProps', this).call(this), {
                formName: form,
                group: group,
                index: index
            });
        }
    }]);

    return FieldArrayEntry;
}(_baseField.BaseField);

FieldArrayEntry.propTypes = _extends({}, _baseField.BaseField.propTypes, {
    entry: _propTypes2.default.shape({
        form: _propTypes2.default.string.isRequired,
        group: _propTypes2.default.string.isRequired,
        index: _propTypes2.default.number.isRequired
    }).isRequired
});