'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Field = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _provider = require('../provider/provider');

var _provider2 = require('../provider/provider.actions');

var _baseField = require('./base-field');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Field = exports.Field = function (_BaseField) {
    _inherits(Field, _BaseField);

    function Field() {
        _classCallCheck(this, Field);

        return _possibleConstructorReturn(this, (Field.__proto__ || Object.getPrototypeOf(Field)).apply(this, arguments));
    }

    _createClass(Field, [{
        key: 'getFieldId',
        value: function getFieldId() {
            var _props = this.props,
                form = _props.form,
                name = _props.name;

            return form + '#' + name;
        }
    }, {
        key: 'dispatchRegisterField',
        value: function dispatchRegisterField() {
            var _props2 = this.props,
                form = _props2.form,
                name = _props2.name,
                children = _props2.children;

            _provider.FormEventDispatcher.dispatchRegisterField(form, name, this.state);
        }
    }, {
        key: 'dispatchFieldPropsChanged',
        value: function dispatchFieldPropsChanged(nextFieldProps) {
            _provider.FormEventDispatcher.dispatchFieldPropsChanged(this.props.form, this.props.name, nextFieldProps);
        }
    }, {
        key: 'dispatchUnregisterField',
        value: function dispatchUnregisterField() {
            var _props3 = this.props,
                form = _props3.form,
                name = _props3.name;

            _provider.FormEventDispatcher.dispatchUnregisterField(form, name);
        }
    }, {
        key: 'dispatchFieldChanged',
        value: function dispatchFieldChanged(value, files) {
            var _props4 = this.props,
                form = _props4.form,
                name = _props4.name;

            _provider.FormEventDispatcher.dispatchFieldChanged(form, name, value, files);
        }
    }, {
        key: 'dispatchFieldBlur',
        value: function dispatchFieldBlur(nextState) {
            var _props5 = this.props,
                form = _props5.form,
                name = _props5.name;

            _provider.FormEventDispatcher.dispatchFieldBlur(form, name, nextState);
        }
    }, {
        key: 'getChildProps',
        value: function getChildProps() {
            return _extends({}, _get(Field.prototype.__proto__ || Object.getPrototypeOf(Field.prototype), 'getChildProps', this).call(this), {
                formName: this.props.form
            });
        }
    }]);

    return Field;
}(_baseField.BaseField);

Field.propTypes = _extends({}, _baseField.BaseField.propTypes, {
    form: _propTypes2.default.string.isRequired
});